"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var async_component_1 = require("./async-component");
var util_1 = require("./util");
/**
 * bundle container
 *
 * @author gcy[of1518]
 * @date 2017.06
 */
var BundleView = /** @class */ (function (_super) {
    __extends(BundleView, _super);
    function BundleView(props) {
        var _this = _super.call(this, props) || this;
        /**
         * 加载Bundle（业务线main.js入口）
         *
         * @param { any } param
         */
        _this.loadBundle = function (param) { return __awaiter(_this, void 0, void 0, function () {
            var name, source;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        name = param.name, source = param.source;
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                if (window["@bundle-" + name]) {
                                    resolve({ default: window["@bundle-" + name] });
                                }
                                else {
                                    // TODO:目前只支持单入口js,后期会提供多入口js,让业务线有 更好的split方案
                                    Object.keys(source).forEach(function (k) {
                                        var v = source[k];
                                        if (v.includes(".css")) {
                                            util_1.appendLink({ name: name + "-" + k, href: v });
                                        }
                                        else if (v.includes(".js")) {
                                            //通过<script/> append dom来load js
                                            util_1.appendScript({
                                                name: name + "-" + k,
                                                src: v,
                                                onload: function () {
                                                    resolve({ default: window["@bundle-" + name] });
                                                },
                                                onerror: function () {
                                                    reject(name + "|" + v + "\u52A0\u8F7D\u5931\u8D25\uFF01");
                                                },
                                            });
                                        }
                                    });
                                }
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        return _this;
    }
    BundleView.prototype.render = function () {
        var _this = this;
        var bundles = this.props.bundles;
        var bundlesNode = (bundles || []).map(function (v, k) {
            var _a = util_1.splitObject(v, ["key", "name", "title", "source"]), l = _a[0], r = _a[1];
            var name = l.name;
            return (React.createElement(react_router_dom_1.Route, __assign({ key: "@bundle_r_" + name }, r, { strict: true, render: function (props) { return (React.createElement(async_component_1.default, __assign({}, v, props, { render: function () { return _this.loadBundle(__assign({}, v)); } }))); } })));
        });
        return bundlesNode ? React.createElement(react_router_dom_1.Switch, null, bundlesNode) : null;
    };
    BundleView.defaultprops = {
        bundles: [],
    };
    return BundleView;
}(React.Component));
exports.default = BundleView;
