"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
/**
 * AsyncView
 */
class AsyncComponent extends React.Component {
    constructor(props) {
        super(props);
        this.unmount = false;
        this.state = {
            component: null,
        };
    }
    componentWillUnmount() {
        this.unmount = true;
    }
    componentDidMount() {
        return __awaiter(this, void 0, void 0, function* () {
            const { render } = this.props;
            if (this.unmount)
                return;
            try {
                const { default: component } = yield render();
                this.setState({ component });
            }
            catch (e) {
                console.error(e);
            }
        });
    }
    render() {
        const { placeholder, children } = this.props;
        const C = this.state.component;
        React.createElement(C, this.props, children);
        return C ? React.createElement(C, Object.assign({}, this.props)) : placeholder;
    }
}
AsyncComponent.defaultProps = {
    render: () => null,
    placeholder: null,
};
exports.default = AsyncComponent;
/**
 * asyncView container
 *
 * @author gcy[fo1518]
 * code split and lazy load
 * func retrun react container component
 */
exports.asyncViewFactory = (render, opt, placeholder = null) => { return _a = class extends React.Component {
        constructor(props) {
            super(props);
            this.unmount = false;
            this.state = {
                component: null,
            };
        }
        componentWillUnmount() {
            this.unmount = true;
        }
        componentDidMount() {
            return __awaiter(this, void 0, void 0, function* () {
                const { render } = this.props;
                if (this.unmount)
                    return;
                try {
                    const { default: component } = yield render();
                    this.setState({ component });
                }
                catch (e) {
                    console.error(e);
                }
            });
        }
        render() {
            const C = this.state.component;
            return C ? React.createElement(C, Object.assign({}, this.props)) : placeholder;
        }
    },
    _a.defaultProps = Object.assign({}, opt),
    _a; var _a; };
