"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_router_dom_1 = require("react-router-dom");
const async_component_1 = require("./async-component");
const util_1 = require("./util");
/**
 * bundle container
 *
 * @author gcy[of1518]
 * @date 2017.06
 */
class BundleView extends React.Component {
    constructor(props) {
        super(props);
        /**
         * 加载Bundle（业务线main.js入口）
         *
         * @param { any } param
         */
        this.loadBundle = (param) => __awaiter(this, void 0, void 0, function* () {
            const { name, source } = param;
            return yield new Promise((resolve, reject) => {
                if (window["@bundle-" + name]) {
                    resolve({ default: window["@bundle-" + name] });
                }
                else {
                    // TODO:目前只支持单入口js,后期会提供多入口js,让业务线有 更好的split方案
                    Object.keys(source).forEach(k => {
                        let v = source[k];
                        if (v.includes(".css")) {
                            util_1.appendLink({ name: `${name}-${k}`, href: v });
                        }
                        else if (v.includes(".js")) {
                            //通过<script/> append dom来load js
                            util_1.appendScript({
                                name: `${name}-${k}`,
                                src: v,
                                onload: () => {
                                    resolve({ default: window["@bundle-" + name] });
                                },
                                onerror: () => {
                                    reject(`${name}|${v}加载失败！`);
                                },
                            });
                        }
                    });
                }
            });
        });
    }
    render() {
        let { bundles } = this.props;
        let bundlesNode = (bundles || []).map((v, k) => {
            let [l, r] = util_1.splitObject(v, ["key", "name", "title", "source"]);
            const { name } = l;
            return (React.createElement(react_router_dom_1.Route, Object.assign({ key: "@bundle_r_" + name }, r, { strict: true, render: props => (React.createElement(async_component_1.default, Object.assign({}, v, props, { render: () => this.loadBundle(Object.assign({}, v)) }))) })));
        });
        return bundlesNode ? React.createElement(react_router_dom_1.Switch, null, bundlesNode) : null;
    }
}
BundleView.defaultprops = {
    bundles: [],
};
exports.default = BundleView;
