"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_router_dom_1 = require("react-router-dom");
const async_component_1 = require("./async-component");
const util_1 = require("./util");
/**
 * chunk page container
 *
 * @author gcy[of1518]
 * @date 2017.06
 */
class ChunkView extends React.Component {
    constructor(props) {
        super(props);
        /**
         * 递归遍历所有路由
         *
         * @param { Array } entries
         */
        this.routeContainer = (entries) => (React.createElement(react_router_dom_1.Switch, null, (entries || []).map((v, k) => {
            let [l, r] = util_1.splitObject(v, ["name", "title", "unauthorize", "routes", "render"]);
            let { name, title, unauthorize, routes: children } = l;
            let { path } = r;
            if (Array.isArray(children) && children.length > 0) {
                return (React.createElement(react_router_dom_1.Route, Object.assign({}, r, { render: props => (React.createElement(async_component_1.default, Object.assign({}, v, props, { render: () => this.loadChunk(Object.assign({}, v)) }), this.routeContainer(children))) })));
            }
            else {
                return (React.createElement(react_router_dom_1.Route, Object.assign({}, r, { render: props => (React.createElement(async_component_1.default, Object.assign({}, v, props, { render: () => this.loadChunk(Object.assign({}, v)) }))) })));
            }
        })));
        /**
         * 加载Chunk（页面分片chunkFile.js入口）
         *
         * @param {any} param chunk name
         */
        this.loadChunk = (param) => __awaiter(this, void 0, void 0, function* () {
            const { name, source, render } = param;
            return yield new Promise((resolve, reject) => {
                render()
                    .then((mod) => {
                    resolve(mod);
                })
                    .catch(err => {
                    reject({
                        error: err,
                        msg: "chunk加载错误-main",
                    });
                });
            });
        });
    }
    componentDidMount() {
        // SPA页面，直接回到页首
        const node = document.getElementsByClassName("root-page")[0];
        node && (node.scrollTop = 0);
    }
    render() {
        let { entries } = this.props;
        return this.routeContainer(entries) || null;
    }
}
ChunkView.defaultProps = {
    entries: [],
};
exports.default = ChunkView;
